"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const t = __importStar(require("@babel/types"));
const isReactComponent_1 = require("./utils/isReactComponent");
const stateProp = 'ReactComponentsSet';
function isValidLeftSide(node) {
    return (t.isMemberExpression(node) &&
        t.isIdentifier(node.property) &&
        node.property.name === 'displayName');
}
function isValidRightSide(node) {
    return t.isStringLiteral(node);
}
function isExistsReactComponent(node, reactComponentsSet) {
    if (t.isMemberExpression(node) &&
        t.isIdentifier(node.object) &&
        reactComponentsSet.has(node.object.name)) {
        return true;
    }
    return false;
}
function displayNameTransform({ template }) {
    const wrapWithEnvCheck = template(`
              if (process.env.NODE_ENV !== "production") {
                NODE;
              }
            `, { placeholderPattern: /^NODE$/ });
    return {
        visitor: {
            Program(path, state) {
                state.set(stateProp, new Set());
            },
            Function(path, state) {
                var _a, _b;
                if (!(0, isReactComponent_1.isReactComponent)(path)) {
                    return;
                }
                const { node } = path;
                let reactFunctionName;
                if (t.isFunctionDeclaration(node)) {
                    reactFunctionName = (_a = node.id) === null || _a === void 0 ? void 0 : _a.name;
                }
                if (t.isArrowFunctionExpression(path) || t.isFunctionExpression(path)) {
                    const variableDeclaration = path.findParent((parentPath) => t.isVariableDeclarator(parentPath));
                    if (variableDeclaration &&
                        t.isVariableDeclarator(variableDeclaration === null || variableDeclaration === void 0 ? void 0 : variableDeclaration.node) &&
                        t.isIdentifier(variableDeclaration === null || variableDeclaration === void 0 ? void 0 : variableDeclaration.node.id)) {
                        reactFunctionName = (_b = variableDeclaration.node.id) === null || _b === void 0 ? void 0 : _b.name;
                    }
                }
                if (reactFunctionName) {
                    const ReactComponentsSet = state.get(stateProp);
                    ReactComponentsSet.add(reactFunctionName);
                }
            },
            AssignmentExpression(path, state) {
                const { node } = path;
                const reactComponentsSet = state.get(stateProp);
                if (node.operator !== '=' ||
                    !isValidLeftSide(node.left) ||
                    !isValidRightSide(node.right) ||
                    !isExistsReactComponent(node.left, reactComponentsSet)) {
                    return;
                }
                path.parentPath.replaceWith(wrapWithEnvCheck({ NODE: path.node }));
                path.parentPath.skip();
            },
        },
    };
}
exports.default = displayNameTransform;
