"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isReactComponent = exports.isClass = void 0;
const t = __importStar(require("@babel/types"));
// Taken from https://github.com/layershifter/babel-plugin-transform-react-handled-props/blob/2ec5afc98d5436d8cda78f10454879df64e0204c/src/util/isReactComponent.js#L4
function containsJSX(path) {
    if (t.isJSXElement(path))
        return true;
    let containJSX;
    path.traverse({
        JSXElement(jsxPath) {
            containJSX = true;
            jsxPath.stop();
        },
    });
    return containJSX;
}
function isRenderMethod(member) {
    return t.isClassMethod(member) && t.isIdentifier(member.key, { name: 'render' });
}
function hasRenderMethod(path) {
    var _a, _b;
    return (_b = (_a = path.node) === null || _a === void 0 ? void 0 : _a.body) === null || _b === void 0 ? void 0 : _b.body.some(isRenderMethod);
}
function hasSuperClass({ node: { superClass } }) {
    return !!superClass;
}
function isClass(path) {
    return t.isClassDeclaration(path) || t.isClassExpression(path);
}
exports.isClass = isClass;
function isFunction(path) {
    if (t.isFunctionDeclaration(path)) {
        return true;
    }
    if (!t.isArrowFunctionExpression(path) && !t.isFunctionExpression(path)) {
        return false;
    }
    return t.isVariableDeclarator(path.parent);
}
function isReactClass(path) {
    return isClass(path) && hasSuperClass(path) && hasRenderMethod(path);
}
function isReactFunction(path) {
    return isFunction(path) && containsJSX(path.get('body'));
}
function isReactExotic(path) {
    if (!t.isFunction(path)) {
        return false;
    }
    const callee = path.parent.callee;
    if (!t.isMemberExpression(callee)) {
        return false;
    }
    return (t.isIdentifier(callee.property, { name: 'memo' }) ||
        t.isIdentifier(callee.property, { name: 'forwardRef' }));
}
function isReactComponent(path) {
    return isReactClass(path) || isReactFunction(path) || isReactExotic(path);
}
exports.isReactComponent = isReactComponent;
